# initial color
hue = 201
saturation = 95
lightness = 57

# our layer
square = new Layer
	size: 250
	borderRadius: 9
	backgroundColor: "hsl(#{hue}, #{saturation}, #{lightness})"
	point: Align.center
	scale: 0.94
	shadowColor: "White"
	shadowY: 16
	shadowBlur: 32

square.animationOptions =
	curve: "spring(300, 20)"

square.draggable = yes
square.draggable.constraints = Screen.frame

# initial y position layer = relative hue value 
square.midY = Utils.modulate 201, [0,360], [square.height/2,Screen.height-(square.height/2)]

# color label
label = new TextLayer
	width: 200
	height: 46
	borderRadius: 23
	backgroundColor: "rgba(0,0,0,0.5)"
	point: Align.center
	parent: square
	text: square.backgroundColor.toHslString()
	color: "#fff"
	fontSize: 17
	textAlign: Align.center
	lineHeight: 2.8

# Start of drag movement
square.onDragStart ->
	this.animate
		scale: 1
		shadowColor: "rgba(153,153,153,1)"

# While moving (also because of momentum)
square.onMove ->
	hue = Utils.modulate this.midY, [square.height/2,Screen.height-(square.height/2)], [0,360], yes
	lightness = Utils.modulate this.midX, [square.width/2,Screen.width-(square.width/2)], [0,100], yes
	
	# set new backgroundColor
	this.backgroundColor = "hsl(#{hue}, #{saturation}, #{lightness})"
	label.text = this.backgroundColor.toHslString()

# Put down when it came to a complete standstill
square.onDragAnimationEnd ->
	this.animate
		scale: 0.94
		shadowColor: "White"
